/*
 *	versionid.h - handle various incantations for SID's
 *
 * #ident "@(#)head:local-1_0-v0:versionid.h,v 1.2 1994/11/22 18:36:21 woods Exp"
 * #ident "@(#)derrived_from:sccsid.h	1.4	93/04/11 01:31:16 (woods)"
 *
 *
 * USE (as the very first statements in a C source module w/out '\'s):
 *
 * with CVS/RCS:
 *	#define SID	"@(#)modulename/path:$Name\$:$Id\$"
 * or with SCCS:
 *	#define SID	"%Z\%%Y\%:%M\%	%I\%	%E\% %U\% (%Q\%)"
 *
 *	#include <versionid.h>
 *
 * USE (as the very first statements in a C header module w/out '\'s):
 *
 *	#define SID_NM	module_id	* the full name of the static array *
 *
 * with CVS/RCS:
 *	#define SID_H	"@(#)modulename/path:$Name\$:$Id\$"
 * or with SCCS
 *	#define SID_H	"%Z\%%Y\%:%M\%	%I\%	%E\% %U\% (%Q\%)"
 *
 *	#include <versionid.h>
 *
 * NOTE:  assumes SYSVR3 or SYSVR4 or SMART_CPP will be defined on the
 *	  compiler command line if appropriate.
 *
 * WARNING:  as a side-effect, this file define's and undef's
 *	     both SMART_CPP and MYconst
 */

/* maybe this should have (defined(sun) && defined(sparc)) ???? */
#if !defined(_AIX) && (defined(SYSVR3) || defined(SYSVR4) || defined(sun))
# define SMART_CPP
# define SMART_IDENT
#endif

#if defined(SYSVR2)	/* You might want this, but it's usually a no-op. */
/*# define SMART_CPP		/* use this if your compiler has #sccs */
/*# define SMART_SCCS		/* you must also uncomment '#sccs' lines below */
#endif

#if defined(__STDC__) && (__STDC__ > 0)
# define MYconst	const
#else
# define MYconst	/* no_op */
#endif

#ifdef SMART_CPP

# ifdef SID
#  ifdef SMART_IDENT
#   ident	SID	/* comment this out if your cpp blows up */
#  endif
#  ifdef SMART_SCCS
#   include "You must uncomment the #sccs lines for SMART_SCCS to work!"
/*#   sccs	SID	/* comment the above line if you uncomment this one */
#  endif
#  undef SID
# else
#  ifdef SID_H
#   ifdef SID_NM
#    ifdef SMART_IDENT
#     ident	SID_H	/* unset SMART_CPP if your compiler blows up */
#    endif
#    ifdef SMART_SCCS
#     include "You must uncomment the #sccs lines for SMART_SCCS to work!"
/*#     sccs	SID_H	/* comment the above line if you uncomment this one */
#    endif
#    undef SID_NM
#    undef SID_H
#   else
#    include	"ERROR: you must define SID_NM to use SID_H"
#   endif
#  else
#   include	"ERROR: you must define either SID or SID_H to use sccsid.h"
#  endif
# endif

#else /* !SMART_CPP */

# ifdef SID
#  if !(defined(lint) || defined(M_LINT)) || defined(DEBUG)
static MYconst char	sccsid[] = SID;
#  endif
# undef SID
# else
#  ifdef SID_H
#   ifdef SID_NM
#    if !(defined(lint) || defined(M_LINT)) || defined(DEBUG)
static MYconst char	SID_NM[] = SID_H;
#    endif
#    undef SID_NM
#    undef SID_H
#   else
#    include	"ERROR: you must define SID_NM to use SID_H"
#   endif
#  else
#   include	"ERROR: you must define either SID or SID_H to use sccsid.h"
#  endif
# endif

#endif

#undef MYconst
#ifdef SMART_CPP
# undef SMART_CPP
#endif
#ifdef SMART_IDENT
# undef SMART_IDENT
#endif
#ifdef SMART_SCCS
# undef SMART_SCCS
#endif
